from django.shortcuts import render
from django.http import (HttpResponse, Http404, JsonResponse, HttpResponseNotAllowed, HttpResponseForbidden,
                         HttpResponseBadRequest)
from django.contrib import messages
import os, traceback, StringIO

def exception2Str(n,lines=False):
    b = StringIO.StringIO()
    traceback.print_exc(file=b)
    b = b.getvalue()
    if lines and n:
        return '\n'.join(b.split('\n')[-n:])
    return b if not n else b[-n:]

# Create your views here.
def home(request):
    if request.method == 'POST':
        try:
            from gen_invoice import generate_pdf
            json = request.POST['json']
            pdf = generate_pdf(json)
            resp = HttpResponse(content=pdf, content_type='application/pdf')
            resp['Content-Disposition'] = 'inline; filename=%s' % 'invoice'
            return resp
        except:
            for m in exception2Str(200).split('\n'):
                messages.error(request,m)
    here = os.path.abspath(os.path.dirname(__file__))
    with open(os.path.join(here,'data','invoice.json'),'r') as f:
        json = f.read()
    return render(request, 'genpdf/home.html',context=dict(json=json))
